package ass.excercises.cvi8.datagen;

import java.io.File;
import java.io.FileNotFoundException;
import java.io.PrintWriter;

import org.apache.commons.lang3.RandomStringUtils;

/**
 * Allows to generate datasets for webserver / cache testing
 */
public class DataGenerator {

	public static void main(String[] args) throws FileNotFoundException {
		// generates 256 1MB files in data_256 folder
		DataGenModel model = new DataGenModel("data_256", 1, 256);
		generate(model);
	}

	public static void generate(DataGenModel dgen) throws FileNotFoundException {
		File folder = new File(dgen.getFolder());
		if(!folder.exists()) {
			folder.mkdirs();
		}
		for(int i = 0; i < dgen.fileCount; i++) {
			String fname = dgen.getFolder()+"/data"+i+".txt";
			try(PrintWriter pw = new PrintWriter(fname)) {
				String line = RandomStringUtils.randomAlphanumeric(50);
				int length = line.getBytes().length;
				for(int y = 0; y < 1000000 / length; y++) {
					pw.write(line);
					pw.write("\n");
				}
				System.out.println(fname + " written!");
			}
		}
		System.out.println("All generated!");
	}
}

class DataGenModel {
	protected final String folder;
	/**
	 * File size in MB
	 */
	protected final int fileSize;
	protected final int fileCount;

	public DataGenModel(String folder, int fileSize, int fileCount) {
		this.folder = folder;
		this.fileSize = fileSize;
		this.fileCount = fileCount;
	}

	public String getFolder() {
		return folder;
	}

	public int getFileSize() {
		return fileSize;
	}

	public int getFileCount() {
		return fileCount;
	}
}
