package ass.excercises.cvi8.formbuilder.html;

import ass.excercises.cvi8.formbuilder.IFormBuilder;

public class HtmlFormBuilder implements IFormBuilder {

	private final StringBuilder sb = new StringBuilder();
	
	public HtmlFormBuilder() {
		sb.append("<link rel='stylesheet' href='https://maxcdn.bootstrapcdn.com/bootstrap/3.3.7/css/bootstrap.min.css'>\n");
		sb.append("<div class='.col-md-8 .col-md-offset-1'><form class=\"form-horizontal\" method='POST'>\n");
	}
	
	@Override
	public IFormBuilder addTextField(String name, String label) {
		addInput(name, label, "input");
		return this;
	}
	

	@Override
	public IFormBuilder addCheckbox(String name) {
		addCheckOrRadio(name, name, "checkbox");
		return this;
	}
	
	@Override
	public IFormBuilder addRadio(String name, String[] values) {
		for(int i = 0; i < values.length; i++) {
			addCheckOrRadio(name, values[i], "radio");
		}
		return this;
	}
	
	protected void addCheckOrRadio(String name, String label, String type) {
		sb.append("<div class=\"form-group\">" +
				"    <div class=\"col-sm-offset-2 col-sm-10\">" +
				"      <div class='"+type+"'>" +
				"        <label for='"+name+"_"+label+"'>" +
				"          <input id='"+name+"_"+label+"' name='"+name+"' type='"+type+"' value='"+label+"'> " + label +
				"        </label>" +
				"      </div>" +
				"    </div>" +
				"  </div>");
	}

	@Override
	public HtmlForm build() {
		addCheckOrRadio("submit", "Submit", "submit");
		sb.append("</form></div>");
		return new HtmlForm(sb.toString());
	}

	protected void addInput(String name, String label, String type) {
		sb.append(
				"<div class=\"form-group\">" +
						"    <label for=\""+name+"\" class=\"col-sm-2 control-label\">"+label+"</label>" +
						"    <div class=\"col-sm-10\">" +
						"      <input type=\""+type+"\" class=\"form-control\" id=\""+name+"\" name=\""+name+"\">" +
						"    </div>" +
						"  </div>"
				);
	}
}
