package ass.excercises.cvi8.formbuilder.swing;

import java.awt.event.ActionListener;
import java.util.Map;
import java.util.Optional;
import java.util.function.Supplier;
import java.util.stream.Collectors;

import javaslang.Tuple;

import javax.swing.JButton;
import javax.swing.JFrame;

import ass.excercises.cvi8.formbuilder.IForm;

public class SwingForm implements IForm {

	private final JFrame frame;
	private final Map<String, Supplier<String>> nameMap;
	private final JButton btnSave;
	
	public SwingForm(JFrame frame, JButton btnSave, Map<String, Supplier<String>> nameMap) {
		super();
		this.frame = frame;
		this.nameMap = nameMap;
		this.btnSave = btnSave;
	}
	
	@Override
	public Optional<String> getValue(String name) {
		return nameMap.containsKey(name) ? Optional.of(nameMap.get(name).get()) : Optional.<String>empty();
	}
	
	@Override
	public Optional<String> render() {
		frame.setVisible(true);
		frame.pack();
		return Optional.empty();
	}
	
	public void addActionListener(ActionListener actionListener) {
		btnSave.addActionListener(actionListener);
	}

	@Override
	public String toString() {
		return nameMap
				.entrySet()
				.stream()
				.map(entry -> Tuple.of(entry.getKey(), entry.getValue().get()))
				.map(Object::toString)
				.collect(Collectors.joining("\n"));
	}
	
	
	
}
