package ass.excercises.cvi8.snippets;

import java.util.List;
import java.util.Map;
import java.util.stream.Collectors;
import java.util.stream.IntStream;

public class Grouping {
	
	public static void main(String[] args) {
		
		// wrong usage of groupingBy
		Map<Integer, List<Integer>> collectWrong = IntStream.range(1, 10)
		.boxed()
		// groupingBy cannot return constant! 
		// because there will be only single group, which is of no use
		.collect(Collectors.groupingBy(i -> 2));
		
		System.out.println("==== Wrong ====");
		System.out.println(collectWrong);
		// prints out: {2=[1, 2, 3, 4, 5, 6, 7, 8, 9]}
		
		// --------------------- CORRECT -----------------------------------------
		// correct use, this example groups numbers into two groups: odds and even
		Map<Integer, List<Integer>> collect = IntStream.range(1, 10)
		.boxed()
		.collect(Collectors.groupingBy(i -> ((i % 2) == 0) ? 0 : 1));
		
		System.out.println("==== Correct ====");
		System.out.println(collect);
		// prints out: {0=[2, 4, 6, 8], 1=[1, 3, 5, 7, 9]}
	}
	
}
